From 4a141fcec2fdcd66dfdef1382d679845d7cbbdbb Mon Sep 17 00:00:00 2001
From: Sinisa Veseli <sveseli@aps.anl.gov>
Date: Tue, 21 Apr 2015 13:06:23 +0000
Subject: [PATCH] fixed case where db account is the same as unix account;
 fixed db ownership problem for dev environment

---
 sbin/dm_create_db.sh | 13 ++++++++++---
 1 file changed, 10 insertions(+), 3 deletions(-)

diff --git a/sbin/dm_create_db.sh b/sbin/dm_create_db.sh
index a51acbc0..a91b8bf6 100755
--- a/sbin/dm_create_db.sh
+++ b/sbin/dm_create_db.sh
@@ -95,7 +95,11 @@ createDb() {
     echo "Creating database $DM_DB_NAME"
     ${PG_DIR}/bin/createdb -U $DM_DB_USER -h $DM_DB_HOST -p $DM_DB_PORT $DM_DB_NAME || return 1
     echo "Creating database schema for $DM_DB_NAME"
-    ${PG_DIR}/bin/psql -U $DM_DB_USER -h $DM_DB_HOST -p $DM_DB_PORT -d $DM_DB_NAME -f $DB_CREATE_SCRIPT || return 1
+    dbCreateScript=/tmp/`basename $DB_CREATE_SCRIPT.$$`
+    cmd="cat $DB_CREATE_SCRIPT | sed 's?OWNER TO.*?OWNER TO $DM_DB_USER;?g' > $dbCreateScript"
+    eval $cmd
+    ${PG_DIR}/bin/psql -U $DM_DB_USER -h $DM_DB_HOST -p $DM_DB_PORT -d $DM_DB_NAME -f $dbCreateScript || return 1
+    rm -f $dbCreateScript
     touch $DB_LOCK_FILE
 }
 
@@ -164,9 +168,12 @@ if [ -z "$DM_DB_USER_PASSWORD" ]; then
     stty $sttyOrig
 fi
 
-# Create db user
+# Create db user unless we are running this script under the same 
+# account, when user will be created
 echo "Creating $DM_DB_USER"
-createDbUser $DM_DB_USER -E -d || exit 1
+if [ $DM_DB_USER != `whoami` ]; then
+    createDbUser $DM_DB_USER -E -d || exit 1
+fi
 modifyDbUserPassword $DM_DB_USER $DM_DB_USER_PASSWORD || exit 1
 
 # Create db password file
-- 
GitLab